-- btn_announcement_common.lua
local M = {} -- public interface

local json = require("scripts.dkjson")

function M.report_call_state(tag)
	local callState = GetCallState()
	local callStateText
	if callState == 0 then
		callStateText = "CLOSED"
	elseif callState == 1 then
		callStateText = "INCOMING"
	elseif callState == 2 then
		callStateText = "OUTGOING"
	elseif callState == 3 then
		callStateText = "TRYING"
	elseif callState == 4 then
		callStateText = "RINGING"
	elseif callState == 5 then
		callStateText = "PROGRESS"
	elseif callState == 6 then
		callStateText = "ESTABLISHED"
	elseif callState == 7 then
		callStateText = "TRANSFER"
	elseif callState == 8 then
		callStateText = "TRANSFER_OOD"
	else
		callStateText = "UNKNOWN"
	end

	local event = {}
	event.type = "call_state"
	event.tag = tag
	event.state = callState
	event.state_text = callStateText
	event.call_peer = GetCallPeer()
	event.call_incoming = IsCallIncoming()

	local str = json.encode (event, { indent = false })
	str = "SEND " .. str .. '\r\n'
	PluginSendMessageText("TcpServer.dll", str)
end

function M.report_registration_state(tag)
	event.type = "registration_state"
	event.tag = tag
	enent.state = GetRegistrationState()
	local str = json.encode (event, { indent = false })
	str = "SEND " .. str .. '\r\n'
	PluginSendMessageText("TcpServer.dll", str)
end



local execSourceType = GetExecSourceType()
if execSourceType == 2 then
	M.report_call_state("")
elseif execSourceType == 4 then
	M.report_registration_state("")
end


return M
